#include "SyncCriticalSection.h"
#include "ImplCriticalSection.h"

#include <cassert>

namespace sync
{

// class CCriticalSection

CCriticalSection::CCriticalSection()
: _impl(0)
{
   _impl = new CCriticalSectionImpl();
}

CCriticalSection::CCriticalSection(const CCriticalSection&)
: _impl(0)
{
   _impl = new CCriticalSectionImpl();
}

CCriticalSection& CCriticalSection::operator=(const CCriticalSection&)
{
   return (*this);
}

CCriticalSection::~CCriticalSection() throw()
{
   delete _impl;
   _impl = 0;
}

void CCriticalSection::enter()
{
   assert(_impl != 0);
   _impl->enter();
}

void CCriticalSection::leave()
{
   assert(_impl != 0);
   _impl->leave();
}

bool CCriticalSection::tryEnter()
{
   assert(_impl != 0);
   return _impl->tryEnter();
}

} // namespace sync