#ifndef __SYNC_CRITICAL_SECTION_H_INCLUDED__
#define __SYNC_CRITICAL_SECTION_H_INCLUDED__

namespace sync
{

class CCriticalSection
{
public:
   CCriticalSection();
   ~CCriticalSection() throw();

   // Critical section must have fake public copy constructor and copy operator so
   // class which have CCriticalSection member can have default copy constructor and 
   // copy operator.
   // Copy constructor only create new instance of clitical section like default
   // constructor. Copy operator do nothing.
   CCriticalSection(const CCriticalSection&);
   CCriticalSection& operator=(const CCriticalSection&);

   void enter();
   void leave();
   bool tryEnter();

private:

   class CCriticalSectionImpl;
   CCriticalSectionImpl* _impl;
}; // class CCriticalSection

} // namespace sync

#endif // __SYNC_CRITICAL_SECTION_H_INCLUDED__